futhark-0.25.27: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.CodeGen.ImpGen.GPU.SegScan.TwoPass

Description

Code generation for segmented and non-segmented scans. Uses a fairly inefficient two-pass algorithm, but can handle anything.

Synopsis

- compileSegScan :: Pat LetDecMem -> SegLevel -> SegSpace -> [SegBinOp GPUMem] -> KernelBody GPUMem -> CallKernelGen ()

# Documentation

compileSegScan :: Pat LetDecMem -> SegLevel -> SegSpace -> [SegBinOp GPUMem] -> KernelBody GPUMem -> CallKernelGen () Source #

Compile `SegScan` instance to host-level code with calls to various kernels.